import numpy, cPickle
import matplotlib
import matplotlib.pyplot as plt
import cifar_features
from sklearn import preprocessing

def show(features, labels):
    # only the first 500 samples are considerd for computational efficiency
    u,w,v=numpy.linalg.svd(features[:500,:].T,False)
    max_label = max(labels)
    fig, ax = plt.subplots()
    for l in range(max_label):
        idx = numpy.where(numpy.array(labels)==l)[0]
        print idx.shape
        x=features[idx,:].dot(u[:,0])
        y=features[idx,:].dot(u[:,1])
        ax.plot(x,y,'.')
    plt.show()

if __name__ == "__main__":

    fo = open('cifar-10-batches-py/data_batch_1')
    dict=cPickle.load(fo)
    images=dict['data']
    labels=dict['labels']

    features = cifar_features.grid_mean_std(images, 4)
    print features.shape
    feat_scaled = preprocessing.scale(features)
    show(feat_scaled, labels)
